#!#usr#bin#env python

##########################################################################*                       
######	                       CAMERA MODULE
######
######    Federico B. 2003 - dragonscraft@yahoo.it
######
################################# IMPORTS ################################*

import os
################################# MODULE #################################*

class CVector3(object):

  def __init__(self,x,y,z):
    self.x = x
    self.y = y
    self.z = z
	
################################# CCAMERA ################################*
######
######    This is the class constructor
######
################################# CCAMERA ################################*
class CCamera(object):
  
  def __init__(self):
    vZero = CVector3(0.0, 0.0, 0.0)
    vView = CVector3(0.0, 1.0, 0.5)
    vUp   = CVector3(0.0, 0.0, 0.0)
    
    self.m_vPosition = vZero      # Init the position to zero
    self.m_vView = vView		  # Init the view to a std starting view
    self.m_vUpVector = vUp		  # Init the UpVector
	
  ############################## POSITION CAMERA ########################*
  ######
  ######	This function sets the camera's position and view and up vector.
  ######
  ############################## POSITION CAMERA ########################*	
  def PositionCamera( self, positionX, positionY, positionZ,
                            viewX,     viewY,     viewZ,
                            upVectorX, upVectorY, upVectorZ):
							
    vPosition	= CVector3(positionX, positionY, positionZ)
    vView	= CVector3(viewX, viewY, viewZ)
    vUpVector	= CVector3(upVectorX, upVectorY, upVectorZ)

    # The code above just makes it cleaner to set the variables.
    # Otherwise we would have to set each variable x y and z.

    self.m_vPosition = vPosition		# Assign the position
    self.m_vView    = vView     		# Assign the view
    self.m_vUpVector = vUpVector		# Assign the up vector
	
  ############################# MOVE CAMERA ############################*
  ######
  ######      This will move the camera forward or backward depending on the speed
  ######
  ############################ MOVE CAMERA #############################*
  def MoveCamera(self, speed):
  
    vVector = CVector3(0.0,0.0,0.0)			# Init a vector for our view

    # Below we are getting the "View Vector".  To get a vector from
    # 2 points, we subtract the first point from the second point.  Basically,
    # what this does is give us a direction that we are looking.  That is,
    # How we know which direction we are looking at in 3D. Later we will create
    # functions that will do this stuff for us instead of doing it like this. Read 
    # "Quick Notes" for some more detail on vectors and the camera's view vector.

    # Get our view vector (The direciton we are facing)
    vVector.x = self.m_vView.x - self.m_vPosition.x   # This gets the direction of the X	
    vVector.y = self.m_vView.y - self.m_vPosition.y	# This gets the direction of the Y
    vVector.z = self. m_vView.z - self.m_vPosition.z	# This gets the direction of the Z

    # Below is the code that will move our view and camera position forward or backward.
    # What we are doing is adding adding our (view vector times the speed) plus
    # our current postion and view.  You might be thinking that we should just
    # add#subtract the speed to our view and position, and forget about the vector.
    # Well, the reason why we do this is because we want to go in the direction
    # that we are looking at.  It won't work if we just add the constant speed
    # to the X and Z values of our position and view.  Try it and you will see.
    # Sure, if we are looking DIRECTLY down the X or Z axis it would work, but
    # when we start to rotate out view at a unique angle, it won't work.  Trust me.
    # So basically, if we are looking at a 45 degree angle, we move in that direction.
    # If we want to move forward we pass in a positive speed, and if we want to move
    # backwards, just pass in a negative speed.

    self.m_vPosition.x += vVector.x * speed		# Add our acceleration to our position's X
    self.m_vPosition.z += vVector.z * speed		# Add our acceleration to our position's Z
    self.m_vView.x += vVector.x * speed			# Add our acceleration to our view's X
    self.m_vView.z += vVector.z * speed			# Add our acceleration to our view's Z


	
